Index: issm/trunk/test/Verification/test1_icesheet_noicefront/Square.par
===================================================================
--- issm/trunk/test/Verification/test1_icesheet_noicefront/Square.par	(revision 114)
+++ issm/trunk/test/Verification/test1_icesheet_noicefront/Square.par	(revision 115)
@@ -1,3 +1,5 @@
-%Ok, start defining model parameters here
+%Start defining model parameters here
+
+md.viscosity_overshoot=0.3;
 
 disp('      creating thickness');
@@ -28,2 +30,7 @@
 %Deal with boundary conditions:
 md=SetIceSheetBC(md);
+
+%Parallel options
+md.np=8;
+md.time=50;
+md.waitonlock=1;
Index: issm/trunk/test/Verification/test1_icesheet_noicefront/runme.m
===================================================================
--- issm/trunk/test/Verification/test1_icesheet_noicefront/runme.m	(revision 114)
+++ issm/trunk/test/Verification/test1_icesheet_noicefront/runme.m	(revision 115)
@@ -10,71 +10,78 @@
 % free to tweak the tolerance variable.
 
+%packages and solutions to be tested
+packages={'macayeal','ice','cielo_serial','cielo_parallel'};
+
 %Initialize log message for nightly runs.
-logstring='Verification/test1_icesheet_noicefront: ';
+testname='IceSheetNoIceFront2d_1';
+tolerance=10^-12;
 
-% Create model;
+%go through the solutions requested
+for i=1:length(packages),
+	package=packages{i};
 
-tolerance=10^-13;
+	%initialize model
+	md=model;
+	md=mesh(md,'DomainOutline.exp',50000);
+	md=geography(md,'','');
+	md=parameterize(md,'Square.par');
+	md=setelementstype(md,'macayeal','all');
 
+	%Compute solution using requested package
+	if strcmpi(package,'macayeal'),
 
-md=model;
-md=mesh(md,'DomainOutline.exp',50000);
-md=geography(md,'','');
-md=parameterize(md,'Square.par');
-md=setelementstype(md,'macayeal','all');
+		%DIAGNOSTIC
+		md=solve(md,'diagnostic','macayeal');
+		%check result
+		load ArchiveMacAyealDiag
+		pos=find(ArchiveMacAyealDiag); error_vel=abs(norm((ArchiveMacAyealDiag(pos)-md.vel(pos))./ArchiveMacAyealDiag(pos),2));
+		if (error_vel>tolerance);
+			disp(['test: ' testname  ', solution: diagnostic, package: ' package ' -> ERROR (difference=' num2str(error_vel) ')'])
+		else
+			disp(['test: ' testname  ', solution: diagnostic, package: ' package ' -> SUCCESS (difference=' num2str(error_vel) ')'])
+		end
 
-%Compute solution with MacAyeal's model
-md=solve(md,'diagnostic','macayeal');
-vel_macayeal=md.vel;
+	elseif strcmpi(package,'ice'),
 
-%Compute solution with Ice model
-md=solve(md,'diagnostic','ice');
-vel_ice=md.vel;
+		%DIAGNOSTIC
+		md=solve(md,'diagnostic','ice');
+		%check result
+		load ArchiveIceDiag
+		pos=find(ArchiveIceDiag); error_vel=abs(norm((ArchiveIceDiag(pos)-md.vel(pos))./ArchiveIceDiag(pos),2));
+		if (error_vel>tolerance);
+			disp(['test: ' testname  ', solution: diagnostic, package: ' package ' -> ERROR (difference=' num2str(error_vel) ')'])
+		else
+			disp(['test: ' testname  ', solution: diagnostic, package: ' package ' -> SUCCESS (difference=' num2str(error_vel) ')'])
+		end
 
-%Compute solution with Hutter elements in Ice model
-md=setelementstype(md,'hutter','all');
-md=solve(md,'diagnostic','ice');
-vel_hutter=md.vel;
+	elseif strcmpi(package,'cielo_serial'),
 
+		%DIAGNOSTIC
+		md=solve(md,'diagnostic','cielo');
+		%check result
+		load ArchiveCieloSerialDiag
+		pos=find(ArchiveCieloSerialDiag); error_vel=abs(norm((ArchiveCieloSerialDiag(pos)-md.vel(pos))./ArchiveCieloSerialDiag(pos),2));
+		if (error_vel>tolerance);
+			disp(['test: ' testname  ', solution: diagnostic, package: ' package ' -> ERROR (difference=' num2str(error_vel) ')'])
+		else
+			disp(['test: ' testname  ', solution: diagnostic, package: ' package ' -> SUCCESS (difference=' num2str(error_vel) ')'])
+		end
 
-%Load old velocities and compare with the new model
+	elseif strcmpi(package,'cielo_parallel'),
 
-%Macayeal
-load archive_macayeal
-pos=find(archive_macayeal-vel_macayeal);
-error_vel=abs(norm((archive_macayeal(pos)-vel_macayeal(pos))./archive_macayeal(pos),2));
+		%DIAGNOSTIC
+		md.cluster='wilkes';
+		md=solve(md,'diagnostic_horiz','cielo');
+		%check result
+		load ArchiveCieloParallelDiag
+		pos=find(ArchiveCieloParallelDiag); error_vel=abs(norm((ArchiveCieloParallelDiag(pos)-md.vel(pos))./ArchiveCieloParallelDiag(pos),2));
+		if (error_vel>tolerance);
+			disp(['test: ' testname  ', solution: diagnostic, package: ' package ' -> ERROR (difference=' num2str(error_vel) ')'])
+		else
+			disp(['test: ' testname  ', solution: diagnostic, package: ' package ' -> SUCCESS (difference=' num2str(error_vel) ')'])
+		end
 
-disp(sprintf('numerical difference between old and new version of MacAyeal is : %d', error_vel));
-
-if (error_vel>tolerance);
-	logoutput(logstring,sprintf('%s\n','    ERROR.  Results from MacAyeal model differ from the archive version'));
-else
-	logoutput(logstring,sprintf('%s\n','    SUCCESS. Results from MacAyeal model are comform with the archive version'));
+	else
+		disp(sprintf(['\npackage ' package  ' not supported yet.\n']));
+	end
 end
-
-%Ice
-load archive_ice
-pos=find(archive_ice-vel_ice);
-error_vel=abs(norm((archive_ice(pos)-vel_ice(pos))./archive_ice(pos),2));
-
-disp(sprintf('numerical difference between old and new version of Ice is : %d', error_vel));
-
-if (error_vel>tolerance);
-	logoutput(logstring,sprintf('%s\n','    ERROR. Results from Ice model differ from the archive version'));
-else
-	logoutput(logstring,sprintf('%s\n','    SUCCESS. Results from Ice model are comform with the archive version'));
-end
-
-%Ice with Hutter elements
-load archive_hutter
-pos=find(archive_hutter-vel_hutter);
-error_vel=abs(norm((archive_hutter(pos)-vel_hutter(pos))./archive_hutter(pos),2));
-
-disp(sprintf('numerical difference between old and new version of Ice is : %d', error_vel));
-
-if (error_vel>tolerance);
-	logoutput(logstring,sprintf('%s\n','    ERROR. Results from Ice model with Hutter elements differ from the archive version'));
-else
-	logoutput(logstring,sprintf('%s\n','    SUCCESS. Results from Ice model with Hutter elements are comform with the archive version'));
-end
-
Index: issm/trunk/test/Verification/test1_icesheet_noicefront/updatearchive.m
===================================================================
--- issm/trunk/test/Verification/test1_icesheet_noicefront/updatearchive.m	(revision 114)
+++ issm/trunk/test/Verification/test1_icesheet_noicefront/updatearchive.m	(revision 115)
@@ -6,30 +6,54 @@
 % Just commit the result if you want to.
 
-md=model;
-md=mesh(md,'DomainOutline.exp',50000);
-md=geography(md,'','');
-md=parameterize(md,'Square.par');
-md=setelementstype(md,'macayeal','all');
+%packages and solutions to be tested
+packages={'macayeal','ice','cielo_serial','cielo_parallel'};
 
-%Compute solution with MacAyeal's model
-md=solve(md,'diagnostic','macayeal');
-archive_macayeal=md.vel;
+%go through the solutions requested
+for i=1:length(packages),
+	package=packages{i};
 
-%Save the solution in the directory
-save archive_macayeal archive_macayeal
+	%initialize model
+	md=model;
+	md=mesh(md,'DomainOutline.exp',50000);
+	md=geography(md,'','');
+	md=parameterize(md,'Square.par');
+	md=setelementstype(md,'macayeal','all');
 
-%Compute solution with Ice model
-md=solve(md,'diagnostic','ice');
-archive_ice=md.vel;
+	%Compute solution using requested package
+	if strcmpi(package,'macayeal'),
 
-%Save the solution in the directory
-save archive_ice archive_ice
+		%DIAGNOSTIC
+		md=solve(md,'diagnostic','macayeal');
+		%save archive
+		ArchiveMacAyealDiag=md.vel;
+		save ArchiveMacAyealDiag ArchiveMacAyealDiag
 
-%Compute solution with Hutter elements in Ice model
-md=setelementstype(md,'hutter','all');
-md=solve(md,'diagnostic','ice');
-archive_hutter=md.vel;
+	elseif strcmpi(package,'ice'),
 
-%Save the solution in the directory
-save archive_hutter archive_hutter
+		%DIAGNOSTIC
+		md=solve(md,'diagnostic','ice');
+		%save archive
+		ArchiveIceDiag=md.vel;
+		save ArchiveIceDiag ArchiveIceDiag
 
+	elseif strcmpi(package,'cielo_serial'),
+
+		%DIAGNOSTIC
+		md=solve(md,'diagnostic','cielo');
+		%save archive
+		ArchiveCieloSerialDiag=md.vel;
+		save ArchiveCieloSerialDiag ArchiveCieloSerialDiag
+
+	elseif strcmpi(package,'cielo_parallel'),
+
+		%DIAGNOSTIC
+		md.cluster='wilkes';
+		md=solve(md,'diagnostic_horiz','cielo');
+		%save archive
+		ArchiveCieloParallelDiag=md.vel;
+		save ArchiveCieloParallelDiag ArchiveCieloParallelDiag
+
+	else
+		disp(sprintf(['\npackage ' package  ' not supported yet.\n']));
+	end
+end