Index: issm/trunk/src/m/classes/public/plot/applyoptions.m
===================================================================
--- issm/trunk/src/m/classes/public/plot/applyoptions.m	(revision 825)
+++ issm/trunk/src/m/classes/public/plot/applyoptions.m	(revision 826)
@@ -154,5 +154,5 @@
 
 %latlon
-if iscell(options_structure.latlon),
+if (iscell(options_structure.latlon) | ~isnan(options_structure.latlon)),
 	latlonoverlay(options_structure.latlon,options_structure.latlonnumbering);
 end
Index: issm/trunk/src/m/classes/public/plot/latlonoverlay.m
===================================================================
--- issm/trunk/src/m/classes/public/plot/latlonoverlay.m	(revision 825)
+++ issm/trunk/src/m/classes/public/plot/latlonoverlay.m	(revision 826)
@@ -10,19 +10,56 @@
 %      latlonoverlay(latlon,numbering)
 
-%recover latstep and longstep
-latstep=latlon{1};
-lonstep=latlon{2};
-resolution=latlon{3};
-color=latlon{4};
+%recover arguments (set default parameters if needed)
+%1: latlon
+if ~iscell(latlon),
+	latstep=3;
+	lonstep=3;
+	resolution=0.1;
+	color=[1 1 1];
+else
+	if length(latlon)<2
+		error('latlonoverlay error message: at least 2 arguments are required, or use ''on'' option.');
+	end
+	if length(latlon)==2,
+		latstep=latlon{1};
+		lonstep=latlon{2};
+		resolution=0.1;
+		color=[1 1 1];
+	elseif length(latlon)==3,
+		latstep=latlon{1};
+		lonstep=latlon{2};
+		resolution=latlon{3};
+		color=[1 1 1];
+	else
+		latstep=latlon{1};
+		lonstep=latlon{2};
+		resolution=latlon{3};
+		color=latlon{4};
+	end
+end
 
-if ~iscell(numbering),
+%2: numbering
+if ~iscell(numbering) & isnan(numbering),
 	numbering=0;
 else
-	latgap=numbering{1};
-	longap=numbering{2};
-	colornumber=numbering{3};
-	latangle=numbering{4};
-	lonangle=numbering{5};
-	numbering=1;
+	if ~iscell(numbering),
+		if strcmpi(char(numbering),'on'),
+			latgap=2;
+			longap=2;
+			colornumber=[1 1 1];
+			latangle=0;
+			lonangle=0;
+			numbering=1;
+		else
+			numbering=0;
+		end
+	else
+		latgap=numbering{1};
+		longap=numbering{2};
+		colornumber=numbering{3};
+		latangle=numbering{4};
+		lonangle=numbering{5};
+		numbering=1;
+	end
 end
 
Index: issm/trunk/src/m/classes/public/plot/plot_overlay.m
===================================================================
--- issm/trunk/src/m/classes/public/plot/plot_overlay.m	(revision 825)
+++ issm/trunk/src/m/classes/public/plot/plot_overlay.m	(revision 826)
@@ -60,4 +60,5 @@
 
 %Apply options, without colorbar and without grid
+iscolorbar=(options_structure.colorbar==1 | isnan(options_structure.colorbar));
 options_structure.colorbar=0;
 
@@ -65,5 +66,5 @@
 
 %colorbar
-if options_structure.colorbar,
+if iscolorbar,
 
 	%create colorbar with correct colors and position
@@ -72,6 +73,8 @@
 	colorbar_image_handle=get(colorbar_handle,'Children'); 
 	set(colorbar_image_handle,'CData',colorbar_rgb);
-	if options_structure.colorbarpos,
+	if ~isnan(options_structure.colorbarpos),
 		set(colorbar_handle,'Position',options_structure.colorbarpos);
+	else
+		set(colorbar_handle,'Position',[0.82 0.65 0.03 0.2])
 	end
 
@@ -88,11 +91,10 @@
 	for i=1:numvalues,
 		fraction=(scalevalues(i)-scaleminmax(1))/(scaleminmax(2)-scaleminmax(1));
-		scalevalues(i)=exp(min(log(data))+(max(log(data))-min(log(data)))*fraction);
-
+		scalevalues(i)=round_ice(exp(min(log(data))+(max(log(data))-min(log(data)))*fraction),1);
 		scalestring=[scalestring; sprintf('%8.4g',scalevalues(i))];
 	end
 	set(colorbar_handle,'YTickLabel',scalestring);
 	set(colorbar_handle,'YColor','y');
-	set(colorbar_handle,'FontSize',16);
+	set(colorbar_handle,'FontSize',14);
 end
 
Index: issm/trunk/src/m/classes/public/plot/plotdoc.m
===================================================================
--- issm/trunk/src/m/classes/public/plot/plotdoc.m	(revision 825)
+++ issm/trunk/src/m/classes/public/plot/plotdoc.m	(revision 826)
@@ -93,6 +93,6 @@
 disp('       ''designvariable'': name of design variable for importance factors');
 disp('       ''responsefunction'': name of response function for importance factors');
-disp('       ''latlon'': {latstep lonstep resolution color} where latstep,longstep and resolution are in degrees, color is a [r g b] array');
-disp('       ''latlonnumbering'': {latgap longap colornumber latangle lonangle} where latgap and longap are pixel gaps for the numbers,'); 
+disp('       ''latlon'': ''on'' or {latstep lonstep [resolution [color]]} where latstep,longstep and resolution are in degrees, color is a [r g b] array');
+disp('       ''latlonnumbering'': ''on'' or {latgap longap colornumber latangle lonangle} where latgap and longap are pixel gaps for the numbers,'); 
 disp('                   colornumber is a [r g b] array and latangle and lonangle are angles to flip the numbers');
 disp('       ''northarrow'': add an arrow pointing north, ''on'' for default value or [x0 y0 length [ratio [width]]] where (x0,y0) are the coordinates of the base, and ratio=headlength/length');