Index: issm/trunk/src/c/ModelProcessorx/DiagnosticHoriz/CreateElementsNodesAndMaterialsDiagnosticHoriz.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/DiagnosticHoriz/CreateElementsNodesAndMaterialsDiagnosticHoriz.cpp	(revision 981)
+++ issm/trunk/src/c/ModelProcessorx/DiagnosticHoriz/CreateElementsNodesAndMaterialsDiagnosticHoriz.cpp	(revision 982)
@@ -75,5 +75,4 @@
 	int    matice_mid;
 	double matice_B;
-	double matice_Bbar;
 	double matice_n;
 	
@@ -313,9 +312,8 @@
 				B_avg=B_avg/3;
 				matice_B=B_avg;
-				matice_Bbar=B_avg;
 				matice_n=(double)*(model->n+i);
 				
 				/*Create matice using its constructor:*/
-				matice= new Matice(matice_mid,matice_B,matice_Bbar,matice_n);
+				matice= new Matice(matice_mid,matice_B,matice_n);
 		
 				/*Add matice element to materials dataset: */
@@ -441,9 +439,8 @@
 				B_avg=B_avg/6;
 				matice_B= B_avg;
-				matice_Bbar= B_avg;
 				matice_n=(double)*(model->n+i);
 		
 				/*Create matice using its constructor:*/
-				matice= new Matice(matice_mid,matice_B,matice_Bbar,matice_n);
+				matice= new Matice(matice_mid,matice_B,matice_n);
 		
 				/*Add matice element to materials dataset: */
Index: issm/trunk/src/c/ModelProcessorx/DiagnosticHutter/CreateElementsNodesAndMaterialsDiagnosticHutter.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/DiagnosticHutter/CreateElementsNodesAndMaterialsDiagnosticHutter.cpp	(revision 981)
+++ issm/trunk/src/c/ModelProcessorx/DiagnosticHutter/CreateElementsNodesAndMaterialsDiagnosticHutter.cpp	(revision 982)
@@ -55,5 +55,4 @@
 	int    matice_mid;
 	double matice_B;
-	double matice_Bbar;
 	double matice_n;
 
@@ -249,9 +248,8 @@
 				matice_mid=i+1; //same as the material id from the geom2 elements.
 				matice_B=model->B[i];	
-				matice_Bbar=model->B[i];	
 				matice_n=(double)model->n[1]; //n defined on elements not grids, so take the first value everywhere
 			
 				/*Create matice using its constructor:*/
-				matice= new Matice(matice_mid,matice_B,matice_Bbar,matice_n);
+				matice= new Matice(matice_mid,matice_B,matice_n);
 	
 				/*Add matice element to materials dataset: */
@@ -303,9 +301,8 @@
 					matice_mid=i+1; //same as the material id from the geom2 elements.
 					matice_B=model->B[i];	
-					matice_Bbar=model->B[i];	
 					matice_n=(double)model->n[1]; //n defined on elements not grids, so take the first value everywhere
 				
 					/*Create matice ubeam its constructor:*/
-					matice= new Matice(matice_mid,matice_B,matice_Bbar,matice_n);
+					matice= new Matice(matice_mid,matice_B,matice_n);
 		
 					/*Add matice element to materials dataset: */
Index: issm/trunk/src/c/ModelProcessorx/DiagnosticStokes/CreateElementsNodesAndMaterialsDiagnosticStokes.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/DiagnosticStokes/CreateElementsNodesAndMaterialsDiagnosticStokes.cpp	(revision 981)
+++ issm/trunk/src/c/ModelProcessorx/DiagnosticStokes/CreateElementsNodesAndMaterialsDiagnosticStokes.cpp	(revision 982)
@@ -54,5 +54,4 @@
 	int    matice_mid;
 	double matice_B;
-	double matice_Bbar;
 	double matice_n;
 	
@@ -286,5 +285,4 @@
 			B_avg=B_avg/6;
 			matice_B= B_avg;
-			matice_Bbar= B_avg;
 			matice_n=(double)*(model->n+i);
 			
@@ -292,5 +290,5 @@
 	
 				/*Create matice using its constructor:*/
-				matice= new Matice(matice_mid,matice_B,matice_Bbar,matice_n);
+				matice= new Matice(matice_mid,matice_B,matice_n);
 		
 				/*Add matice element to materials dataset: */
Index: issm/trunk/src/c/ModelProcessorx/DiagnosticVert/CreateElementsNodesAndMaterialsDiagnosticVert.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/DiagnosticVert/CreateElementsNodesAndMaterialsDiagnosticVert.cpp	(revision 981)
+++ issm/trunk/src/c/ModelProcessorx/DiagnosticVert/CreateElementsNodesAndMaterialsDiagnosticVert.cpp	(revision 982)
@@ -53,5 +53,4 @@
 	int    matice_mid;
 	double matice_B;
-	double matice_Bbar;
 	double matice_n;
 	
@@ -248,5 +247,5 @@
 
 		/*Create matice using its constructor:*/
-		matice= new Matice(matice_mid,matice_B,matice_Bbar,matice_n);
+		matice= new Matice(matice_mid,matice_B,matice_n);
 
 		/*Add matice element to materials dataset: */
Index: issm/trunk/src/c/ModelProcessorx/Melting/CreateElementsNodesAndMaterialsMelting.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/Melting/CreateElementsNodesAndMaterialsMelting.cpp	(revision 981)
+++ issm/trunk/src/c/ModelProcessorx/Melting/CreateElementsNodesAndMaterialsMelting.cpp	(revision 982)
@@ -53,5 +53,4 @@
 	int    matice_mid;
 	double matice_B;
-	double matice_Bbar;
 	double matice_n;
 	
@@ -257,9 +256,8 @@
 		B_avg=B_avg/6;
 		matice_B= B_avg;
-		matice_Bbar= B_avg;
 		matice_n=(double)*(model->n+i);
 
 		/*Create matice using its constructor:*/
-		matice= new Matice(matice_mid,matice_B,matice_Bbar,matice_n);
+		matice= new Matice(matice_mid,matice_B,matice_n);
 
 		/*Add matice element to materials dataset: */
Index: issm/trunk/src/c/ModelProcessorx/Prognostic/CreateElementsNodesAndMaterialsPrognostic.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/Prognostic/CreateElementsNodesAndMaterialsPrognostic.cpp	(revision 981)
+++ issm/trunk/src/c/ModelProcessorx/Prognostic/CreateElementsNodesAndMaterialsPrognostic.cpp	(revision 982)
@@ -75,5 +75,4 @@
 	int    matice_mid;
 	double matice_B;
-	double matice_Bbar;
 	double matice_n;
 	
Index: issm/trunk/src/c/ModelProcessorx/Thermal/CreateElementsNodesAndMaterialsThermal.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/Thermal/CreateElementsNodesAndMaterialsThermal.cpp	(revision 981)
+++ issm/trunk/src/c/ModelProcessorx/Thermal/CreateElementsNodesAndMaterialsThermal.cpp	(revision 982)
@@ -54,5 +54,4 @@
 	int    matice_mid;
 	double matice_B;
-	double matice_Bbar;
 	double matice_n;
 	
@@ -253,9 +252,8 @@
 		B_avg=B_avg/6;
 		matice_B= B_avg;
-		matice_Bbar= B_avg;
 		matice_n=(double)*(model->n+i);
 
 		/*Create matice using its constructor:*/
-		matice= new Matice(matice_mid,matice_B,matice_Bbar,matice_n);
+		matice= new Matice(matice_mid,matice_B,matice_n);
 
 		/*Add matice element to materials dataset: */