Index: issm/trunk/etc/environment.csh
===================================================================
--- issm/trunk/etc/environment.csh	(revision 1063)
+++ issm/trunk/etc/environment.csh	(revision 1063)
@@ -0,0 +1,82 @@
+#ISSM_DIR and ISSM_ARCH should have been defined already in your shell settings file (.bashrc, .cshrc, etc ...)
+
+source $ISSM_DIR/etc/environment_variables.csh
+
+
+#MPI
+setenv MPI_DIR
+setenv PATH {$PATH}:{$MPI_DIR}/bin
+setenv LD_LIBRARY_PATH {$LD_LIBRARY_PATH}:$MPI_DIR/lib
+setenv MANPATH {$MANPATH}:$MPI_DIR/man
+setenv MPIRUN_NPROCS 8
+
+#PETSC
+setenv PETSC_DIR
+setenv PETSC_ARCH
+setenv LD_LIBRARY_PATH {$LD_LIBRARY_PATH}:$PETSC_DIR/lib/{$PETSC_ARCH}
+
+#SLEPC
+setenv SLEPC_DIR
+setenv SLEPC_ARCH
+setenv LD_LIBRARY_PATH {$LD_LIBRARY_PATH}:$SLEPC_DIR/lib/{$PETSC_ARCH}
+
+
+#Dakota
+setenv DAKOTA_DIR
+setenv PATH {$PATH}:{$DAKOTA_DIR}/bin
+setenv MANPATH {$MANPATH}:{$MPI_DIR}/man:{$DAKOTA_DIR}/docs/man:{$DAKOTA_DIR}/docs/man-ref
+
+#Qhull
+setenv QHULL_DIR
+setenv LD_LIBRARY_PATH {$LD_LIBRARY_PATH}:{$QHULL_DIR}/lib
+
+
+#Doxygen
+setenv DOXYGEN_DIR
+setenv MANPATH {$MANPATH}:{$DOXYGEN_DIR}/man
+setenv PATH {$PATH}:{$DOXYGEN_DIR}/bin
+
+#MTOC
+setenv MTOC_DIR
+setenv PATH {$PATH}:{$MTOC_DIR}
+
+#MATLAB
+setenv MATLAB_DIR
+setenv LD_LIBRARY_PATH {$LD_LIBRARY_PATH}:{$MATLAB_DIR}/bin/glnxa64
+setenv PATH {$PATH}:{$MATLAB_DIR}/bin
+
+#TRIANGLE
+setenv TRIANGLE_DIR
+
+#METIS
+setenv METIS_DIR
+	
+#BLAS
+setenv BLAS_DIR
+
+#LAPACK
+setenv LAPACK_DIR
+
+#SCALAPACK
+setenv SCALAPACK_DIR
+
+#PLAPACK
+setenv PLAPACK_DIR
+
+#BLACS
+setenv BLACS_DIR
+
+#SOWING
+setenv SOWING_DIR
+setenv PATH {$PATH}:{$SOWING_DIR}/bin
+setenv LD_LIBRARY_PATH {$LD_LIBRARY_PATH}:{$SOWING_DIR}/lib
+setenv MANPATH {$MANPATH}:{$SOWING_DIR}/man
+
+
+#AUTOCONF
+setenv AUTOCONF_DIR
+setenv PATH {$PATH}:{$AUTOCONF_DIR}/bin
+
+#AUTOMAKE
+setenv AUTOMAKE_DIR
+setenv PATH {$PATH}:{$AUTOMAKE_DIR}/bin
Index: issm/trunk/etc/environment.sh
===================================================================
--- issm/trunk/etc/environment.sh	(revision 1062)
+++ issm/trunk/etc/environment.sh	(revision 1063)
@@ -1,11 +1,13 @@
 #ISSM_DIR and ISSM_ARCH should have been defined already in your shell settings file (.bashrc, .cshrc, etc ...)
 
-source $ISSM_DIR/etc/environment_variables
+exit
+
+source $ISSM_DIR/etc/environment_variables.sh
 
 #MPI
 export MPI_DIR
 PATH="$PATH:$MPI_DIR/bin"
-export LD_LIBRARY_PATH="$MPI_DIR/lib"
-export LD_RUN_PATH="$MPI_DIR/lib"
+export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$MPI_DIR/lib"
+export LD_RUN_PATH="$LD_RUN_PATH:$MPI_DIR/lib"
 export MANPATH="$MANPATH:$MPI_DIR/man"
 export MPIRUN_NPROCS=8
Index: issm/trunk/etc/environment_variables.csh
===================================================================
--- issm/trunk/etc/environment_variables.csh	(revision 1063)
+++ issm/trunk/etc/environment_variables.csh	(revision 1063)
@@ -0,0 +1,65 @@
+#
+#
+#This routine can only be run if the ISSM_DIR variable has been correctly set!
+#
+#
+
+#MATLAB
+set MATLAB_DIR=/usr/local/pkgs/matlab-7.6/
+
+#MPI
+set MPI_DIR={$ISSM_DIR}/externalpackages/mpich2/install
+
+#PETSC
+set PETSC_DIR={$ISSM_DIR}/externalpackages/petsc/install
+set PETSC_ARCH=linux-gnu-amd64
+
+#SLEPC
+set SLEPC_DIR={$ISSM_DIR}/externalpackages/slepc/install
+set SLEPC_ARCH=linux-gnu-amd64
+
+#Dakota
+set DAKOTA_DIR={$ISSM_DIR}/externalpackages/dakota/install
+
+#Qhull
+set QHULL_DIR={$ISSM_DIR}/externalpackages/qhull/install
+
+#Doxygen
+set DOXYGEN_DIR={$ISSM_DIR}/externalpackages/doxygen/install
+
+#MTOC
+set MTOC_DIR={$ISSM_DIR}/externalpackages/mtoc/install
+
+#Triangle
+set TRIANGLE_DIR={$ISSM_DIR}/externalpackages/triangle/install
+
+#METIS
+set METIS_DIR={$ISSM_DIR}/externalpackages/metis/install
+
+#BLAS
+set BLAS_DIR={$ISSM_DIR}/externalpackages/petsc/install/externalexternalpackages/fblaslapack
+
+#LAPACK
+set LAPACK_DIR={$ISSM_DIR}/externalpackages/petsc/install/externalexternalpackages/fblaslapack/$PETSC_ARCH
+
+#SCALAPACK
+set SCALAPACK_DIR={$ISSM_DIR}/externalpackages/petsc/install/externalexternalpackages/SCALAPACK/$PETSC_ARCH
+
+#PLAPACK
+set PLAPACK_DIR={$ISSM_DIR}/externalpackages/petsc/install/externalexternalpackages/PLAPACKR32
+
+#BLACS
+set BLACS_DIR={$ISSM_DIR}/externalpackages/petsc/install/externalexternalpackages/blacs-dev/$PETSC_ARCH
+
+#sowing
+set SOWING_DIR={$ISSM_DIR}/externalpackages/sowing/install
+
+#BLACS
+set BLACS_DIR={$ISSM_DIR}/externalpackages/petsc/install/externalexternalpackages/blacs-dev/$PETSC_ARCH
+
+#Development packages
+#automake
+set AUTOMAKE_DIR={$ISSM_DIR}/devpackages/automake/install
+
+#autoconf
+set AUTOCONF_DIR={$ISSM_DIR}/devpackages/autoconf/install
Index: issm/trunk/etc/environment_variables.sh
===================================================================
--- issm/trunk/etc/environment_variables.sh	(revision 1063)
+++ issm/trunk/etc/environment_variables.sh	(revision 1063)
@@ -0,0 +1,70 @@
+#
+#
+#This routine can only be run if the ISSM_DIR variable has been correctly set!
+#
+#
+
+
+#MATLAB
+MATLAB_DIR="/usr/local/pkgs/matlab-7.6/"
+
+#MPI
+MPI_DIR="$ISSM_DIR/externalpackages/mpich2/install"
+
+#PETSC
+PETSC_DIR="$ISSM_DIR/externalpackages/petsc/install"
+PETSC_ARCH="linux-gnu-amd64"
+
+#SLEPC
+SLEPC_DIR="$ISSM_DIR/externalpackages/slepc/install"
+SLEPC_ARCH="linux-gnu-amd64"
+
+#Dakota
+DAKOTA_DIR="$ISSM_DIR/externalpackages/dakota/install"
+
+#Qhull
+QHULL_DIR="$ISSM_DIR/externalpackages/qhull/install"
+
+#Doxygen
+DOXYGEN_DIR="$ISSM_DIR/externalpackages/doxygen/install"
+
+#MTOC
+MTOC_DIR="$ISSM_DIR/externalpackages/mtoc/install"
+
+#Triangle
+TRIANGLE_DIR="$ISSM_DIR/externalpackages/triangle/install"
+
+#METIS
+METIS_DIR="$ISSM_DIR/externalpackages/metis/install"
+
+#BLAS
+BLAS_DIR="$ISSM_DIR/externalpackages/petsc/install/externalexternalpackages/fblaslapack"
+
+#LAPACK
+LAPACK_DIR="$ISSM_DIR/externalpackages/petsc/install/externalexternalpackages/fblaslapack/$PETSC_ARCH"
+
+#SCALAPACK
+SCALAPACK_DIR="$ISSM_DIR/externalpackages/petsc/install/externalexternalpackages/SCALAPACK/$PETSC_ARCH"
+
+#PLAPACK
+PLAPACK_DIR="$ISSM_DIR/externalpackages/petsc/install/externalexternalpackages/PLAPACKR32"
+
+#BLACS
+BLACS_DIR="$ISSM_DIR/externalpackages/petsc/install/externalexternalpackages/blacs-dev/$PETSC_ARCH"
+
+#sowing
+SOWING_DIR="$ISSM_DIR/externalpackages/sowing/install"
+
+#BLACS
+BLACS_DIR="$ISSM_DIR/externalpackages/petsc/install/externalexternalpackages/blacs-dev/$PETSC_ARCH"
+
+
+
+
+
+#Development packages
+#automake
+AUTOMAKE_DIR="$ISSM_DIR/devpackages/automake/install"
+
+#autoconf
+AUTOCONF_DIR="$ISSM_DIR/devpackages/autoconf/install"